<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Pos extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model(array('project','tracker','po'));

	}

	public function index(){
		$data = array();
		$data['list'] = $this->project->get_projectlist();

		$this->load->view('template/header');
		$this->load->view('po/index',$data);
		$this->load->view('template/footer');
	}

	public function listpo($id){
		$data = array();

		$data['project'] = $this->project->get_projectinfo($id);
		$data['survey'] = $this->tracker->get_trackerprojectinfo($id,"SURVEY");
		$data['install'] = $this->tracker->get_trackerprojectinfo($id,"INSTALLATION");
		$data['list'] = $this->po->get_polist("SURVEY",$id);
		$data['projectid'] = $id;

		$this->load->view('template/header');
		$this->load->view('po/list',$data);
		$this->load->view('template/footer');
	}

	public function add_survey($id=null){

		if($this->input->post()){
			
			if($this->po->add_survey()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect("/pos/listpo/$id");
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect("/pos/add_survey/$id");
			}
		}

		$data = array();
		$data['projectid'] = $id;

		$this->load->view('template/header');
		$this->load->view('po/add_survey',$data);
		$this->load->view('template/footer');
	}

	public function edit_survey($projectid=null,$id=null){

		if($this->input->post()){
			
			if($this->po->edit_survey()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect("/pos/listpo/$projectid");
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect("/pos/edit_survey/$projectid/$id");
			}
		}

		$data = array();
		$data['list'] = $this->po->get_poinfo($id);
		$data['projectid'] = $projectid;

		$this->load->view('template/header');
		$this->load->view('po/edit_survey',$data);
		$this->load->view('template/footer');
	}

	public function view_survey($id=null){

		$data['list'] = $this->po->get_poinfo($id);

		$this->load->view('template/header');
		$this->load->view('po/view_survey',$data);
		$this->load->view('template/footer');
	}

	public function delete($projectid=null,$id=null){
		$this->po->delete($id);
		redirect("pos/listpo/$projectid");
	}

	public function listpoinstall($id){
		$data = array();

		$data['project'] = $this->project->get_projectinfo($id);
		$data['survey'] = $this->tracker->get_trackerprojectinfo($id,"SURVEY");
		$data['install'] = $this->tracker->get_trackerprojectinfo($id,"INSTALLATION");
		$data['list'] = $this->po->get_polist("INSTALLATION",$id);
		$data['projectid'] = $id;

		$this->load->view('template/header');
		$this->load->view('po/listinstall',$data);
		$this->load->view('template/footer');
	}

	public function add_install($id=null){

		if($this->input->post()){
			
			if($this->po->add_install()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect("/pos/listpoinstall/$id");
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect("/pos/add_install/$id");
			}
		}

		$data = array();
		$data['projectid'] = $id;

		$this->load->view('template/header');
		$this->load->view('po/add_install',$data);
		$this->load->view('template/footer');
	}

	public function edit_install($projectid=null,$id=null){

		if($this->input->post()){
			
			if($this->po->edit_install()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect("/pos/listpoinstall/$projectid");
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect("/pos/edit_survey/$projectid/$id");
			}
		}

		$data = array();
		$data['list'] = $this->po->get_poinfo($id);
		$data['projectid'] = $projectid;

		$this->load->view('template/header');
		$this->load->view('po/edit_install',$data);
		$this->load->view('template/footer');
	}

	public function view_install($id=null){

		$data['list'] = $this->po->get_poinfo($id);

		$this->load->view('template/header');
		$this->load->view('po/view_install',$data);
		$this->load->view('template/footer');
	}

	public function delete_install($projectid=null,$id=null){
		$this->po->delete($id);
		redirect("pos/listpoinstall/$projectid");
	}
}

?>