<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Projects extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model(array('project'));

	}

	public function index(){
		$data = array();
		$data['list'] = $this->project->get_projectlist();

		$this->load->view('template/header');
		$this->load->view('project/index',$data);
		$this->load->view('template/footer');
	}

	public function add(){

		if($this->input->post()){
			
			if($this->project->add()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect('/projects/index');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect('/projects/add');
			}
		}

		$data = array();

		$this->load->view('template/header');
		$this->load->view('project/add',$data);
		$this->load->view('template/footer');
	}

	public function view($id=null){

		$data['list'] = $this->project->get_projectinfo($id);

		$this->load->view('template/header');
		$this->load->view('project/view',$data);
		$this->load->view('template/footer');
	}

	public function edit($id=null){

		if($this->input->post()){
			
			if($this->project->edit()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Edited.');
				redirect('/projects/index');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Edited');
				redirect('/projects/edit');
			}
		}

		$data['list'] = $this->project->get_projectinfo($id);

		$this->load->view('template/header');
		$this->load->view('project/edit',$data);
		$this->load->view('template/footer');
	}

	public function delete($id=null){
		$this->project->delete($id);
		redirect('/projects/index');
	}

	public function ajax_projectinfo(){
		$data = $this->project->get_projectinfo($this->input->post('id'));

		echo '
		<table class="table table-bordered table-hover">
            <thead>
                <tr class="bg-blue-soft bg-font-blue-soft">
                    <th> Project Name </th>
                    <th> State </th>
                    <th> Loc ID </th>
                    <th> Cluster </th>
                    <th> Site Name </th>
                    <th> Status</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td> '.$data->project_name.' </td>
                    <td> '.$data->state.' </td>
                    <td> '.$data->loc_id.' </td>
                    <td> '.$data->cluster.' </td>
                    <td> '.$data->site_name.' </td>
                    <td> '.strtoupper($data->status).' </td>
                </tr>
            </tbody>
        </table>
		';
	}
}

?>