<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Trackers extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		$this->load->model(array('project','tracker'));

	}

	public function index(){
		$data = array();
		$data['list'] = $this->tracker->get_trackerlist("SURVEY");

		$this->load->view('template/header');
		$this->load->view('tracker/index',$data);
		$this->load->view('template/footer');
	}

	public function add_survey(){

		if($this->input->post()){
			
			if($this->tracker->add_survey()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect('/trackers/index');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect('/trackers/add_survey');
			}
		}

		$data = array();
		$data['project'] = $this->project->get_projectlist();

		$this->load->view('template/header');
		$this->load->view('tracker/add_survey',$data);
		$this->load->view('template/footer');
	}

	public function view_survey($id=null){

		$data['list'] = $this->tracker->get_trackerinfo($id);

		$this->load->view('template/header');
		$this->load->view('tracker/view_survey',$data);
		$this->load->view('template/footer');
	}

	public function edit_survey($id=null){

		if($this->input->post()){
			
			if($this->tracker->edit_survey()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect('/trackers/index');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect('/trackers/edit_survey');
			}
		}

		$data = array();
		$data['project'] = $this->project->get_projectlist();
		$data['list'] = $this->tracker->get_trackerinfo($id);

		$this->load->view('template/header');
		$this->load->view('tracker/edit_survey',$data);
		$this->load->view('template/footer');
	}

	public function delete($id=null){
		$this->tracker->delete($id);
		redirect('/trackers/index');
	}

	public function installation(){
		$data = array();
		$data['list'] = $this->tracker->get_trackerlist("INSTALLATION");

		$this->load->view('template/header');
		$this->load->view('tracker/installation',$data);
		$this->load->view('template/footer');
	}

	public function add_install(){

		if($this->input->post()){
			
			if($this->tracker->add_install()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect('/trackers/installation');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect('/trackers/add_install');
			}
		}

		$data = array();
		$data['project'] = $this->project->get_projectlist();

		$this->load->view('template/header');
		$this->load->view('tracker/add_install',$data);
		$this->load->view('template/footer');
	}

	public function view_install($id=null){

		$data['list'] = $this->tracker->get_trackerinfo($id);

		$this->load->view('template/header');
		$this->load->view('tracker/view_install',$data);
		$this->load->view('template/footer');
	}

	public function edit_install($id=null){

		if($this->input->post()){
			
			if($this->tracker->edit_install()){
				$this->session->set_flashdata('flashSuccess', 'The Record Successfull Saved.');
				redirect('/trackers/installation');
			}else{
				$this->session->set_flashdata('flashError', 'The Record Unsuccessfull Saved');
				redirect('/trackers/edit_install');
			}
		}

		$data = array();
		$data['project'] = $this->project->get_projectlist();
		$data['list'] = $this->tracker->get_trackerinfo($id);

		$this->load->view('template/header');
		$this->load->view('tracker/edit_install',$data);
		$this->load->view('template/footer');
	}

	public function delete_install($id=null){
		$this->tracker->delete($id);
		redirect('/trackers/installation');
	}
}

?>