<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Users extends CI_Model	{
	function __construct()
	{
		parent::__construct();
	}

	function list_user(){
		$this->db->from('users');
		$this->db->from('user_profiles');
		$this->db->from('user_status');
		$this->db->from('cizacl_roles');
		$this->db->where('user_id = user_profile_user_id');
		$this->db->where('user_cizacl_role_id = cizacl_role_id');
		$this->db->where('user_profile_user_status_code = user_status_code');
		$this->db->where('user_id != 1');
		$query = $this->db->get();

		return $query->result();
	}

	function get_role(){
		//$this->db->select('kenderaan.*,kenderaan_kategori.ketegori_nama,kenderaan_model.nama_model');
		$query = $this->db->get('cizacl_roles');

        return $query->result();
	}

	function get_status(){
		$query = $this->db->get('user_status');
        return $query->result();
	}

	public function get_user($id)
	{

		$this->db->from('users');
		$this->db->from('user_profiles');
		$this->db->from('cizacl_roles');
		$this->db->from('user_status');
		$this->db->where('user_id = '.$id);
		$this->db->where('user_id = user_profile_user_id');
		$this->db->where('user_cizacl_role_id = cizacl_role_id');
		$this->db->where('user_profile_user_status_code = user_status_code');
		$query = $this->db->get();

		return $query->row();

	}

	public function users_add()
	{
		$addnew = array(
			'user_username'		=> $this->input->post('user_username',true),
			'user_password'		=> hash('sha256', $this->input->post('user_password',true)),
			'user_cizacl_role_id'	=> $this->input->post('user_cizacl_role_id',true)
		);
		if($this->db->insert('users',$addnew))	{
			unset($addnew);
			$addnew = array(
				'user_profile_user_id'			=> $this->db->insert_id(),
				'user_profile_user_status_code'	=> $this->input->post('user_profile_user_status_code',true),
				'user_profile_name'				=> $this->input->post('user_profile_name',true),
				'user_profile_surname'			=> "",
				'user_profile_email'			=> $this->input->post('user_profile_email',true),
				'user_profile_added'			=> mktime(),
				'user_profile_added_by'			=> $this->session->userdata('user_id')
			);

			if($this->db->insert('user_profiles',$addnew))
				return true;
		}
	}

	public function users_update()
	{
		$update = array(
			'user_username'		=> $this->input->post('user_username',true),
			'user_cizacl_role_id'	=> $this->input->post('user_cizacl_role_id',true)
		);
		
		$pwd = $this->input->post('user_password');
		
		if(!empty($pwd))	{
			$update['user_password'] = hash('sha256', $this->input->post('user_password',true));
		}

		if($this->db->update('users', $update, 'user_id = '.$this->input->post('id')))	{
			unset($update);
			$update = array(
				'user_profile_user_id'			=> $this->input->post('id',true),
				'user_profile_user_status_code'	=> $this->input->post('user_profile_user_status_code',true),
				'user_profile_name'				=> $this->input->post('user_profile_name',true),
				'user_profile_surname'			=> "",
				'user_profile_email'			=> $this->input->post('user_profile_email',true),
				'user_profile_edited'			=> mktime(),
				'user_profile_edited_by'		=> $this->session->userdata('user_id')
			);
			
			if($this->db->update('user_profiles', $update, 'user_profile_user_id = '.$this->input->post('id',true)))
				return true;
		}
	}

	public function users_delete($id)
	{
		$this->db->where('user_profile_user_id = '.$id);
		$query = $this->db->get('user_profiles');
		if($query->num_rows())	{
			$row = $query->row();
			if((string)$row->user_profile_added_by !== "0")	{	// Protect system's data
				if($this->db->delete('users', array('user_id' => $id)))
					if($this->db->delete('user_profiles', array('user_profile_user_id' => $id)))
						return true;
				else
					return false;
			}
			else
				return false;
		}
	}

	public function profile_update()
	{
		
		$update['user_password'] = hash('sha256', $this->input->post('user_password',true));

		if($this->db->update('users', $update, 'user_id = '.$this->input->post('id')))
			return true;
	}
}

?>